a = "14159265358979323846264338327950288419716939937510\
    \58209749445923078164062862089986280348253421170679"
b = "82148086513282306647093844609550582231725359408128\
    \48111745028410270193852110555964462294895493038196"
m = length a; fib = map fst $ iterate (\(a,b) -> (b,a+b)) (0,1)
f k 1 = a; f k 2 = b
f k n = if k <= fib!!(n-2) then f k $ n-2 else f (k - fib!!(n-2)) $ n-1
main = putStrLn [(\n -> let (q,r) = divMod (n+m-1) m in (f q $ until
  (\n -> q <= fib!!n) (+1) 1)!!r) $ (127+19*n)*7^n | n <- [17,16..0]]

